## inotify-info 0.0.2

=== Makefile ===
# $@: name of the target file (one before colon)
# $<: name of first prerequisite file (first one after colon)
# $^: names of all prerequisite files (space separated)
# $*: stem (bit which matches the % wildcard in rule definition)
#
# VAR = val: Normal setting - values within are recursively expand when var used.
# VAR := val: Setting of var with simple expansion of values inside - values are expanded at decl time.
# VAR ?= val: Set var only if it doesn't have a value.
# VAR += val: Append val to existing value (or set if var didn't exist).

# To use static analyzer:
#   http://clang-analyzer.llvm.org/scan-build.html
# Ie:
#   scan-build -k -V --use-analyzer ~/bin/clang make

NAME = inotify-info

CFG ?= release
ifeq ($(CFG), debug)
    ASAN ?= 1
endif

LD = $(CC)
RM = rm -f
MKDIR = mkdir -p
VERBOSE ?= 0

INOTIFYINFO_VERSION ?= $(shell git describe --tags --dirty 2>/dev/null || echo unknown)

COMPILER = $(shell $(CC) -v 2>&1 | grep -q "clang version" && echo clang || echo gcc)

WARNINGS = -Wall -Wextra -Wpedantic -Wmissing-include-dirs -Wformat=2 -Wshadow
ifneq ($(COMPILER),clang)
  # https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html
  WARNINGS += -Wsuggest-attribute=format -Wall
endif

DEFINES  = -D_LARGEFILE64_SOURCE=1 -D_FILE_OFFSET_BITS=64
DEFINES += -DINOTIFYINFO_VERSION=\"$(INOTIFYINFO_VERSION)\"

CFLAGS += $(WARNINGS) $(DEFINES)
CFLAGS += -std=gnu99 -fno-exceptions

CXXFLAGS += $(WARNINGS) $(DEFINES)
CXXFLAGS += -std=c++11 -fno-exceptions -fno-rtti -Woverloaded-virtual

LIBS = -Wl,--no-as-needed -lm -ldl -lpthread -lstdc++

CFILES = \
	inotify-info.cpp \
	lfqueue/lfqueue.c

# Useful GCC address sanitizer checks not enabled by default
# https://kristerw.blogspot.com/2018/06/useful-gcc-address-sanitizer-checks-not.html

ifeq ($(ASAN), 1)
	# https://gcc.gnu.org/gcc-5/changes.html
	#  -fsanitize=float-cast-overflow: check that the result of floating-point type to integer conversions do not overflow;
	#  -fsanitize=vptr: enable checking of C++ member function calls, member accesses and some conversions between pointers to base and derived classes, detect if the referenced object does not have the correct dynamic type.
	ASAN_FLAGS = -fno-omit-frame-pointer -fno-optimize-sibling-calls
	ASAN_FLAGS += -fsanitize=address # fast memory error detector (heap, stack, global buffer overflow, and use-after free)
	ASAN_FLAGS += -fsanitize=leak # detect leaks
	ASAN_FLAGS += -fsanitize=undefined # fast undefined behavior detector
	ASAN_FLAGS += -fsanitize=float-divide-by-zero # detect floating-point division by zero;
	ASAN_FLAGS += -fsanitize=bounds # enable instrumentation of array bounds and detect out-of-bounds accesses;
	ASAN_FLAGS += -fsanitize=object-size # enable object size checking, detect various out-of-bounds accesses.
	ASAN_FLAGS += -fsanitize=alignment # enable alignment checking, detect various misaligned objects;
	CFLAGS += $(ASAN_FLAGS)
	CXXFLAGS += $(ASAN_FLAGS)
	LDFLAGS += $(ASAN_FLAGS)
endif

ifeq ($(CFG), debug)
	ODIR=_debug
	CFLAGS += -O0 -DDEBUG
	CFLAGS += -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -D_GLIBCXX_SANITIZE_VECTOR -D_LIBCPP_DEBUG=1 -D_LIBCPP_ENABLE_DEBUG_MODE=1
else
	ODIR=_release
	CFLAGS += -O2 -DNDEBUG
endif

PROJ = $(ODIR)/$(NAME)

ifeq ($(VERBOSE), 1)
	VERBOSE_PREFIX=
else
	VERBOSE_PREFIX=@
endif

C_OBJS = ${CFILES:%.c=${ODIR}/%.o}
OBJS = ${C_OBJS:%.cpp=${ODIR}/%.o}

all: $(PROJ)

$(ODIR)/$(NAME): $(OBJS)
	@echo "Linking $@...";
	$(VERBOSE_PREFIX)$(LD) $(LDFLAGS) $^ $(LIBS) -o $@

-include $(OBJS:.o=.d)

$(ODIR)/%.o: %.c Makefile
	$(VERBOSE_PREFIX)echo "---- $< ----";
	@$(MKDIR) $(dir $@)
	$(VERBOSE_PREFIX)$(CC) -MMD -MP $(CFLAGS) -o $@ -c $<

$(ODIR)/%.o: %.cpp Makefile
	$(VERBOSE_PREFIX)echo "---- $< ----";
	@$(MKDIR) $(dir $@)
	$(VERBOSE_PREFIX)$(CXX) -MMD -MP $(CXXFLAGS) -o $@ -c $<

.PHONY: lint
lint:
	find . -name '*.h' -o -name '*.c' -o -name '*.cpp' | xargs clang-format -i --style=webkit

.PHONY: clean

clean:
	@echo Cleaning...
	$(VERBOSE_PREFIX)$(RM) $(PROJ)
	$(VERBOSE_PREFIX)$(RM) $(OBJS)
	$(VERBOSE_PREFIX)$(RM) $(OBJS:.o=.d)
	$(VERBOSE_PREFIX)$(RM) $(OBJS:.o=.dwo)

define RELEASE_RULES
inotify-info-$(TAG).tar.gz:
	git archive --prefix=inotify-info-$(TAG)/ v$(TAG) | gzip -n > $$@
endef
$(foreach TAG,$(shell git tag 2>/dev/null | sed -n '/^v/ s/^v//p'),$(eval $(RELEASE_RULES)))

=== debian/changelog ===
inotify-info (0.0.2-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 0.0.2.
  * Removing march.patch, not needed anymore.
  * Removing dwz.patch, not needed anymore.
  * Setting INOTIFYINFO_VERSION to debian package version.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 03 Jun 2024 22:01:31 +0200

inotify-info (0.0.1-2) sid; urgency=medium

  * Uploading to sid.
  * Building without -march=native (Closes: #1071076).
  * Refreshing dwz.patch.
  * Renumbering patches.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 18 May 2024 14:41:59 +0200

inotify-info (0.0.1-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 0.0.1.
  * Using codename instead of suitname in changelog.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 05 May 2024 13:02:50 +0200

inotify-info (0~20240209-1) sid; urgency=medium

  * Initial upload to sid.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 25 Apr 2024 09:14:44 +0200

=== debian/rules ===
#!/usr/bin/make -f

export INOTIFYINFO_VERSION = $(shell dpkg-parsechangelog -SVersion)

%:
	dh ${@}

execute_after_dh_auto_clean:
	rm -rf _release

## inotify-info 0.0.3

=== debian/changelog ===
inotify-info (0.0.3-4) sid; urgency=medium

  * Simplifying watch file.

 -- Daniel Baumann <daniel@debian.org>  Fri, 02 May 2025 07:53:11 +0200

inotify-info (0.0.3-3) sid; urgency=medium

  * Updating to standards version 4.7.1.
  * Updating to standards version 4.7.2.

 -- Daniel Baumann <daniel@debian.org>  Wed, 19 Mar 2025 20:44:36 +0100

inotify-info (0.0.3-2) sid; urgency=medium

  * Updating source url in copyright.
  * Updating vcs fields.
  * Updating email address.
  * Trimming debian changelog.
  * Updating year in debian copyright for 2025.

 -- Daniel Baumann <daniel@debian.org>  Wed, 05 Feb 2025 15:54:20 +0100

inotify-info (0.0.3-1) sid; urgency=medium

  * Merging upstream version 0.0.3.
  * Removing manual debhelper install file, not needed anymore with new
    upstream version.
  * Enabling non-silent output during build.

 -- Daniel Baumann <daniel@debian.org>  Sat, 13 Jul 2024 13:02:30 +0200

=== debian/control ===
Source: inotify-info
Section: utils
Priority: optional
Maintainer: Daniel Baumann <daniel@debian.org>
Build-Depends:
 debhelper-compat (= 13),
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/mikesart/inotify-info
Vcs-Browser: https://forgejo.debian.net/linux/inotify-info
Vcs-Git: https://forgejo.debian.net/linux/inotify-info

Package: inotify-info
Section: utils
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: tracking the number of inotify watches
 The Linux inotify system can be difficult to debug when the system runs out of
 watches. inotify-info allows tracking down how many inotify watches, instances,
 and which files are being watched.

=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,9 @@
 
 execute_after_dh_auto_clean:
 	rm -rf _release
+
+override_dh_auto_build:
+	dh_auto_build -- VERBOSE=1
+
+override_dh_auto_install:
+	dh_auto_install -- PREFIX=$(CURDIR)/debian/inotify-info/usr

=== debian/watch ===
version=4
https://github.com/mikesart/inotify-info/tags .*/v?(\d.*)@ARCHIVE_EXT@
